SystemOrganization addCategory: #'Pier-Wysiwyg'!

WAComponent subclass: #PRWysiwygEditor
	instanceVariableNames: 'pierWikiText'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Wysiwyg'!

!PRWysiwygEditor class methodsFor: 'as yet unclassified' stamp: 'NickAger 7/6/2011 10:45'!
register
	(WAAdmin register: self asApplicationAt: 'wysiwygtest')
		addLibrary: JQDeploymentLibrary;
		preferenceAt: #scriptGeneratorClass put: JQScriptGenerator.! !

!PRWysiwygEditor methodsFor: 'rendering' stamp: 'NickAger 7/6/2011 15:49'!
editorJs: textAreaId
	"see: 
		* http://developer.yahoo.com/yui/examples/editor/toolbar_editor.html
		* http://developer.yahoo.com/yui/docs/editor.js.html
		* http://developer.yahoo.com/yui/editor/
		* http://developer.yahoo.com/yui/examples/editor/cal_editor.html
		* http://developer.yahoo.com/yui/examples/editor/flickr_editor.html"
	^ 
'var myEditor = new YAHOO.widget.Editor("', textAreaId, '", {
	height: "300px",
	width: "600px",
	toolbar: {
		focusAtStart: true,
		buttons: [ 
	    		{ group: "parastyle", label: "",
				buttons: [
					{ type: "select", label: "Normal", value: "heading", disabled: true,
						menu: [
							{ text: "Normal", value: "none", checked: true },
							{ text: "Header 1", value: "h1" },
							{ text: "Header 2", value: "h2" },
							{ text: "Header 3", value: "h3" },
							{ text: "Header 4", value: "h4" },
							{ text: "Header 5", value: "h5" },
							{ text: "Header 6", value: "h6" }
						]
					}
				]
			},
			{ type: "separator" },
			{ group: "indentlist", label: "",
			    buttons: [
			        { type: "push", label: "Create an Unordered List", value: "insertunorderedlist" },
			        { type: "push", label: "Create an Ordered List", value: "insertorderedlist" }
			    ]
			},
			{ type: "separator" },
			{ group: "textstyle" , label: "",
				buttons: [
            			{ type: "push", label: "Bold CTRL + SHIFT + B",  value: "bold" }, 
					{ type: "push", label: "Italic CTRL + SHIFT + I", value: "italic" }, 
					{ type: "push", label: "Underline CTRL + SHIFT + U", value: "underline" },
					{ type: "push", label: "Code", value: "code" },
					{ type: "push", label: "Strikeout", value: "strike" },
					{ type: "separator" },
					{ type: "push", label: "Subscript", value: "subscript", disabled: true },
					{ type: "push", label: "Superscript", value: "superscript", disabled: true },
				 ]
			 },
	    		{ type: "separator" },
			{ group: "insertitem", label: "",
			    buttons: [
				{ type: "push", label: "Horizontal Rule", value: "rule" },
			        { type: "push", label: "HTML Link CTRL + SHIFT + L", value: "createlink", disabled: true },
			        { type: "push", label: "Insert Image", value: "insertimage" }
			    ]
			}
		]
	}
} );

myEditor.cmd_code = function (o) {
	this.execCommand("inserthtml", "<code>" + this._getSelection() + "</code>");
}
myEditor.cmd_rule = function (o) {
	this.execCommand("inserthtml", "<hr>");
}
myEditor.cmd_strike = function (o) {
	this.execCommand("inserthtml", "<del>" + this._getSelection() + "</del>");
}

myEditor.render();
' withInternetLineEndings

"	
{ group: ''formatting'' , label: ''Formatting'',
  buttons: [
	{ type: ''separator'' },
	{ type: ''push'', label: ''Remove Formatting'', value: ''removeformat'', disabled: true },
	{ type: ''push'', label: ''Show/Hide Hidden Elements'', value: ''hiddenelements'' }
   ]
}
"
! !

!PRWysiwygEditor methodsFor: 'accessing' stamp: 'NickAger 7/6/2011 15:39'!
pierWikiText
	^ pierWikiText ifNil: [ 
		pierWikiText := '!!Wiki Text
 "Edit" Pier wiki text in a ''wysiwyg'' editor.

Currently the editor supports:
# ""Bold""
# ''''Italic''''
# __Underline__
# ==code==
# --strikeout--
# Headings
# line-breaks and paragraphs
# ordered and unordered lists.
# super^^script^^ and sub@@script@@
# horizontal line:
_
The translator also supports the following, although there are no editor buttons to support it:
- definition list and definitions
- preformated.
Still to come support for images, links and tables.' ]! !

!PRWysiwygEditor methodsFor: 'accessing' stamp: 'NickAger 7/5/2011 13:36'!
pierWikiText: anObject
	pierWikiText := anObject! !

!PRWysiwygEditor methodsFor: 'rendering' stamp: 'NickAger 7/6/2011 15:57'!
renderContentOn: html
	
html form: [
	html table
		cellpadding: 0;
		cellspacing: 0;
		with: [
			html tableRow: [	
				html tableData: [ self renderEditorOn: html ].
				html tableData: [
					html button
						bePush;
							onClick: 'myEditor.saveHTML();';
							onClick: ((html jQuery id: #htmlToPierConversion) value: (JSStream on: 'parseHtmlToPierWikiSyntax(myEditor._getDoc().body)'));
							onClick: ((html jQuery ajax script: [:s | s << ((s jQuery id: #pierBackToHtml) html: [: r | self renderPierToHtmlOn: r ]) ]) serialize: (html jQuery id: #htmlToPierConversion));
			with: 'convert >>' ].

				html tableData: [
					html heading level3; with: 'Pier Syntax'.
					html textArea 
						columns: 60;
						rows: 20;
						id: #htmlToPierConversion;
						on: #pierWikiText of: self. ] ].
				
			html tableRow: [
				html tableData
					colSpan: 3;
					with: [ 
						html heading level3; with: 'Pier wiki -> html'.
						html div
							id: #pierBackToHtml;
							with: [
								self renderPierToHtmlOn: html ] ] ] ] ]! !

!PRWysiwygEditor methodsFor: 'rendering' stamp: 'NickAger 7/6/2011 11:54'!
renderEditorOn: html
	| textAreaId |
	
	html
		textArea
			id: (textAreaId := html nextId);
			with: [
				self renderPierToHtmlOn: html].
	html script: (self editorJs: textAreaId)
! !

!PRWysiwygEditor methodsFor: 'rendering' stamp: 'NickAger 7/5/2011 13:37'!
renderPierToHtmlOn: html
	"renders wiki text into html"
	| parsedStructure renderer |
		
	parsedStructure := PRDocumentParser parseStream: self pierWikiText readStream.
	renderer := PRViewRenderer new.
	renderer withinContentDo: [
		renderer start: parsedStructure in: self on: html ]! !

!PRWysiwygEditor methodsFor: 'updating' stamp: 'NickAger 7/6/2011 15:51'!
updateRoot: anHtmlRoot
	super updateRoot: anHtmlRoot.
	
	"See YUI editor documentation: 
		* http://developer.yahoo.com/yui/editor/
		* http://yuiblog.com/assets/pdf/cheatsheets/editor.pdf"
	
	anHtmlRoot stylesheet url: 'http://yui.yahooapis.com/2.9.0/build/assets/skins/sam/skin.css'.
	anHtmlRoot javascript url: 'http://yui.yahooapis.com/2.9.0/build/yahoo-dom-event/yahoo-dom-event.js'.
	anHtmlRoot javascript url: 'http://yui.yahooapis.com/2.9.0/build/element/element-min.js'.

	"Needed for Menus, Buttons and Overlays used in the Toolbar"
	anHtmlRoot javascript url: 'http://yui.yahooapis.com/2.9.0/build/container/container_core-min.js'.
	anHtmlRoot javascript url: 'http://yui.yahooapis.com/2.9.0/build/menu/menu-min.js'.
	anHtmlRoot javascript url: 'http://yui.yahooapis.com/2.9.0/build/button/button-min.js'.
	"Source file for Rich Text Editor"
	anHtmlRoot javascript url: 'http://yui.yahooapis.com/2.9.0/build/editor/editor-min.js'.	
	
	anHtmlRoot bodyAttributes addClass: 'yui-skin-sam'.
	
	anHtmlRoot javascript url: PRWysiwygFileLibrary / #parseHtmlToPierWikiSyntaxJs.
	
	anHtmlRoot stylesheet add: '
.yui-toolbar-group {
	margin-top: 4px;
}
.yui-skin-sam .yui-toolbar-container .yui-toolbar-code span.yui-toolbar-icon {
	background-image: url( /files/PREditorScripts/toolbar.png );
	background-position: -64px 0px;
	margin-left: 5px;
	margin-top: 2px;
}

.yui-skin-sam .yui-toolbar-container .yui-toolbar-rule span.yui-toolbar-icon {
	background-image: url( /files/PREditorScripts/toolbar.png );
	background-position: -208px 0px;
	margin-left: 5px;
	margin-top: 2px;
}

.yui-skin-sam .yui-toolbar-container .yui-toolbar-strike span.yui-toolbar-icon {
	background-image: url( /files/PREditorScripts/toolbar.png );
	background-position: -48px 0px;
	margin-left: 5px;
	margin-top: 2px;
}
'
	
! !

WAFileLibrary subclass: #PRWysiwygFileLibrary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Wysiwyg'!

!PRWysiwygFileLibrary methodsFor: 'uploaded' stamp: 'NickAger 7/6/2011 15:41'!
parseHtmlToPierWikiSyntaxJs
	^ 'var parseHtmlToPierWikiSyntax = function (startNode) {
	var wikiOutput = [];
	var newLine = "\n"
	
	var surroundingMarkup = function(markup) {
		return function(node) {
			wikiOutput.push(markup);
			walkTheDOM (node.firstChild);
			wikiOutput.push(markup)
		}
	}

	var startLineMarkup = function(markup) {
		return function(node) {
			// if not at the start of the document
			if (wikiOutput.length) {
				wikiOutput.push(newLine);
			}
			if (markup.length) {
				wikiOutput.push(markup);
			}
			walkTheDOM (node.firstChild);
			wikiOutput.push(newLine);
		}
	}
	
	var listWalk = function () {
		return function (node) {
			var startLength = wikiOutput.length;
			walkTheDOM (node.firstChild);
			var endLength = wikiOutput.length;
			
			// remove consecutive new lines. 
			var previousNewLineIndex = -1;
			for (var i = startLength - 1; i < endLength; ++i) {
				if (wikiOutput [i] == newLine) {
					// we have consecutive new lines.
					if (previousNewLineIndex == i - 1) {
						delete wikiOutput [i];
					}
				previousNewLineIndex = i;		
				}
			}
			
			// ensure we finish with a new line
			if (wikiOutput [wikiOutput.length - 1] && wikiOutput [wikiOutput.length - 1] !!= newLine) {
				wikiOutput.push(newLine);
			}
		}
	}
	
	var listElement = function () {
		return function (node) {
			var parentNodeName = nodeName = node.parentNode.nodeName.toLowerCase();
			if (parentNodeName == ''ul'') {
				startLineMarkup(''- '')(node)
			}
			if (parentNodeName == ''ol'') {
				startLineMarkup(''# '')(node)
			}
		}
	}
	
	var tableMarkup = function () {
		return function () {}
	}
	
	var anchor = function(node) {
		return function(node) {
			if(node.getAttribute("href")) {
				var baseUrl = window.location.host;
				var anchorUrl = node.getAttribute("href");
				var url = (anchorUrl.indexOf(baseURl) == 0) ? anchorUrl.substr(0, baseUrl.length) : anchorUrl;

				wikiOutput.push("*");
				walkTheDOM(node.firstChild);
				wikiOutput.push(">");
				wikiOutput.push(node.getAttribute("href"));
				wikiOutput.push("*");
			}
		}
	}
	
	var handleText = function(node) {
		var text = node.nodeValue;

		// if the string starts with a newLine strip it.
		if (text.length && text [0] == newLine) {
			text = text.substr(1, text.length - 1); 
		}		
		
		// if the string ends with a newLine strip it.
		if (text.length && text [text.length - 1] == newLine) {
			text = text.substr(0, text.length - 2); 
		}
		
		if (text.trim().length !!== 0) {
			wikiOutput.push(text);
		}
	}

	var elementToWikiMarkupMappingTable = {
		''b'': surroundingMarkup(''\"\"''),
		''strong'': surroundingMarkup(''\"\"''),
		''i'': surroundingMarkup("\''\''"),
		''em'': surroundingMarkup("\''\''"),
		''ins'': surroundingMarkup("__"),
		''u'': surroundingMarkup("__"),
		"del": surroundingMarkup("--"),
		''code'': surroundingMarkup("=="),
		''sub'': surroundingMarkup("@@"),
		''sup'': surroundingMarkup("^^"),
		''a'': anchor(),
		''h1'': startLineMarkup (''!!''),
		''h2'': startLineMarkup(''!!!!''), 
		''h3'': startLineMarkup(''!!!!!!''),
		''h4'': startLineMarkup(''!!!!!!!!''), 
		''h5'': startLineMarkup(''!!!!!!!!!!''), 
		''h6'': startLineMarkup(''!!!!!!!!!!!!''),
		''hr'': startLineMarkup(''_''),
		"br": startLineMarkup(''''),
		"p": startLineMarkup(''''),
		"ul": listWalk(),
		"ol": listWalk(),	
		''li'': listElement(),	
		''dl'': startLineMarkup('';''),
		''dd'': startLineMarkup('':''),
		''pre'': startLineMarkup(''=''),
		''hr'': startLineMarkup("_"),
		''table'': tableMarkup()
	}

    var nodeTypes = {
        ELEMENT_NODE: 1,
        ATTRIBUTE_NODE: 2,
        TEXT_NODE: 3,
        CDATA_SECTION_NODE: 4,
        ENTITY_REFERENCE_NODE: 5,
        ENTITY_NODE: 6,
        PROCESSING_INSTRUCTION_NODE: 7,
        COMMENT_NODE: 8,
        DOCUMENT_NODE: 9,
        DOCUMENT_TYPE_NODE: 10,
        DOCUMENT_FRAGMENT_NODE: 11,
        NOTATION_NODE: 12
    }
	
	// the recursive DOM walker
    var walkTheDOM = function (node) {
		if (node === null)
			return ;
			
		switch (node.nodeType) {
            case nodeTypes.ELEMENT_NODE:
			var nodeName = node.nodeName.toLowerCase();
			if (elementToWikiMarkupMappingTable.hasOwnProperty (nodeName)) {
				elementToWikiMarkupMappingTable [nodeName](node);
			}
			break;
                
            case nodeTypes.TEXT_NODE:
			handleText(node);
			break; 
                
            case nodeTypes.ATTRIBUTE_NODE:
            case nodeTypes.CDATA_SECTION_NODE:
            case nodeTypes.ENTITY_REFERENCE_NODE:
            case nodeTypes.ENTITY_NODE:
            case nodeTypes.PROCESSING_INSTRUCTION_NODE:
            case nodeTypes.COMMENT_NODE:
            case nodeTypes.DOCUMENT_NODE:
            case nodeTypes.DOCUMENT_TYPE_NODE:
            case nodeTypes.DOCUMENT_FRAGMENT_NODE:
            case nodeTypes.NOTATION_NODE:
                break;
			}

		walkTheDOM (node.nextSibling);
    }
	walkTheDOM (startNode.firstChild);
	
	return wikiOutput.join('''');
}' withInternetLineEndings! !
